:start

@echo # Configuration for Microsoft Build Engine > Makefile
@echo. >> Makefile
@echo. 
@set prefix=
@set omp=0
@set intel=0
@set fortran=0
@set mpi=0
@set saamg=0
@set longlong=0
@set debug=0
@set usercflags=
@set userfflags=
@set userldflags=

:again

@if "%1" == "-h" goto usage
@if "%1" == "--help" goto usage
@if "%1" == "--prefix" goto setprefix
@if "%1" == "--enable-omp" goto setomp
@if "%1" == "--enable-intel" goto setintel
@if "%1" == "--enable-fortran" goto setfortran
@if "%1" == "--enable-mpi" goto setmpi
@if "%1" == "--enable-saamg" goto setsaamg
@if "%1" == "--enable-longlong" goto setlonglong
@if "%1" == "--enable-debug" goto setdebug
@if "%1" == "--cflags" goto setusercflags
@if "%1" == "--fflags" goto setuserfflags
@if "%1" == "--ldflags" goto setuserldflags
@if "%1" == "" goto genmakefile

:usage

@echo Usage: configure [options]
@echo.	
@echo Options:
@echo.	
@echo.	--prefix PREFIX		Install Lis in directory PREFIX
@echo.	--enable-omp		Enable OpenMP library
@echo.	--enable-intel		Enable Intel Compiler
@echo.	--enable-fortran	Enable Intel Fortran Compiler
@echo.	--enable-mpi		Enable MPI library
@echo.	--enable-saamg		Enable SA-AMG library
@echo.	--enable-longlong	Enable 64bit integer
@echo.	--enable-debug		Enable debugger
@echo.	--cflags FLAG		Pass FLAG to C compiler
@echo.	--fflags FLAG		Pass FLAG to Fortran compiler
@echo.	--ldflags FLAG		Pass FLAG to compiler when linking
@echo.	
@goto end

:setprefix

@shift
@set prefix=%1
@shift
@goto again

:setomp

@set omp=1
@shift
@goto again

:setintel

@set intel=1
@shift
@goto again

:setfortran

@set fortran=1
@shift
@goto again

:setmpi

@set mpi=1
@shift
@goto again

:setsaamg

@set saamg=1
@shift
@goto again

:setlonglong

@set longlong=1
@shift
@goto again

:setdebug

@set debug=1
@shift
@goto again

:setusercflags
@shift
@set usercflags=%1
@shift
@goto again

:setuserfflags
@shift
@set userfflags=%1
@shift
@goto again

:setuserldflags
@shift
@set userldflags=%1
@shift
@goto again

:genmakefile

@echo # Installation directory >> Makefile
@if not "(%prefix%)" == "()" (
@echo PREFIX=%prefix% >> Makefile
) else (
@echo PREFIX=.. >> Makefile
)
@echo. >> Makefile

@if (%omp%) == (1) (
@echo # Enable OpenMP library >> Makefile
@echo omp=1 >> Makefile
@echo. >> Makefile
@echo.	Enable OpenMP library		= yes
) else (
@echo.	Enable OpenMP library		= no
)

@if (%intel%) == (1) (
@echo # Enable Intel Compiler >> Makefile
@echo intel=1 >> Makefile
@echo. >> Makefile
@echo.	Enable Intel Compiler		= yes
) else (
@echo.	Enable Intel Compiler		= no
)

@if (%fortran%) == (1) (
@echo # Enable Intel Fortran Compiler >> Makefile
@echo fortran=1 >> Makefile
@echo. >> Makefile
@echo.	Enable Intel Fortran Compiler	= yes
) else (
@echo.	Enable Intel Fortran Compiler	= no
)

@if (%mpi%) == (1) (
@echo # Enable MPI library >> Makefile
@echo mpi=1 >> Makefile
@echo. >> Makefile
@echo.	Enable MPI library 		= yes
) else (
@echo.	Enable MPI library 		= no
)

@if (%saamg%) == (1) (
@echo # Enable SA-AMG library >> Makefile
@echo saamg=1 >> Makefile
@echo. >> Makefile
@echo.	Enable SA-AMG library		= yes
) else (
@echo.	Enable SA-AMG library		= no
)

@if (%longlong%) == (1) (
@echo # Enable 64bit integer >> Makefile
@echo longlong=1 >> Makefile
@echo. >> Makefile
@echo.	Enable 64bit integer		= yes
) else (
@echo.	Enable 64bit integer		= no
)

@if (%debug%) == (1) (
@echo # Enable Debugging >> Makefile
@echo debug=1 >> Makefile
@echo. >> Makefile
@echo.	Enable Debugging		= yes
) else (
@echo.	Enable Debugging		= no
)

@echo # User-defined C flags >> Makefile
@if not "(%usercflags%)" == "()" (
@echo USER_CFLAGS = %usercflags% >> Makefile
) else (
@echo USER_CFLAGS = >> Makefile
)
@echo. >> Makefile

@echo # User-defined Fortran flags >> Makefile
@if not "(%userfflags%)" == "()" (
@echo USER_FFLAGS = %userfflags% >> Makefile
) else (
@echo USER_FFLAGS = >> Makefile
)
@echo. >> Makefile

@echo # User-defined linker flags >> Makefile
@if not "(%userldflags%)" == "()" (
@echo USER_LDFLAGS = %userldflags% >> Makefile
) else (
@echo USER_LDFLAGS = >> Makefile
)
@echo. >> Makefile
) 

@echo. >> Makefile
@type Makefile.in >> Makefile
@echo.

:end
